pcl::ApproximateProgressiveMorphologicalFilter< PointT > Class Template Reference

Implements the Progressive Morphological Filter for segmentation of ground points. More...

`#include <pcl/segmentation/approximate_progressive_morphological_filter.h>`

Inheritance diagram for pcl::ApproximateProgressiveMorphologicalFilter< PointT >:

## Public Types

typedef pcl::PointCloud< PointT > | PointCloud
Public Types inherited from pcl::PCLBase< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| ApproximateProgressiveMorphologicalFilter ()
| Constructor that sets default values for member variables. More...
virtual | ~ApproximateProgressiveMorphologicalFilter ()
int | getMaxWindowSize () const
| Get the maximum window size to be used in filtering ground returns. More...
void | setMaxWindowSize (int max_window_size)
| Set the maximum window size to be used in filtering ground returns. More...
float | getSlope () const
| Get the slope value to be used in computing the height threshold. More...
void | setSlope (float slope)
| Set the slope value to be used in computing the height threshold. More...
float | getMaxDistance () const
| Get the maximum height above the parameterized ground surface to be considered a ground return. More...
void | setMaxDistance (float max_distance)
| Set the maximum height above the parameterized ground surface to be considered a ground return. More...
float | getInitialDistance () const
| Get the initial height above the parameterized ground surface to be considered a ground return. More...
void | setInitialDistance (float initial_distance)
| Set the initial height above the parameterized ground surface to be considered a ground return. More...
float | getCellSize () const
| Get the cell size. More...
void | setCellSize (float cell_size)
| Set the cell size. More...
float | getBase () const
| Get the base to be used in computing progressive window sizes. More...
void | setBase (float base)
| Set the base to be used in computing progressive window sizes. More...
bool | getExponential () const
| Get flag indicating whether or not to exponentially grow window sizes? More...
void | setExponential (bool exponential)
| Set flag indicating whether or not to exponentially grow window sizes? More...
void | setNumberOfThreads (unsigned int nr_threads=0)
| Initialize the scheduler and set the number of threads to use. More...
virtual void | extract (std::vector< int > &ground)
| This method launches the segmentation algorithm and returns indices of points determined to be ground returns. More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Attributes

int | max_window_size_
| Maximum window size to be used in filtering ground returns. More...
float | slope_
| Slope value to be used in computing the height threshold. More...
float | max_distance_
| Maximum height above the parameterized ground surface to be considered a ground return. More...
float | initial_distance_
| Initial height above the parameterized ground surface to be considered a ground return. More...
float | cell_size_
| Cell size. More...
float | base_
| Base to be used in computing progressive window sizes. More...
bool | exponential_
| Exponentially grow window sizes? More...
unsigned int | threads_
| Number of threads to be used. More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Additional Inherited Members

Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Detailed Description

### template<typename PointT>
class pcl::ApproximateProgressiveMorphologicalFilter< PointT >

Implements the Progressive Morphological Filter for segmentation of ground points.

Description can be found in the article "A Progressive Morphological Filter for Removing Nonground Measurements from Airborne LIDAR Data" by K. Zhang, S. Chen, D. Whitman, M. Shyu, J. Yan, and C. Zhang.

Definition at line 57 of file approximate_progressive_morphological_filter.h.

## Member Typedef Documentation

## PointCloud

template<typename PointT >

typedef pcl::PointCloud<PointT> pcl::ApproximateProgressiveMorphologicalFilter< PointT >::PointCloud

Definition at line 61 of file approximate_progressive_morphological_filter.h.

## Constructor & Destructor Documentation

## ApproximateProgressiveMorphologicalFilter()

template<typename PointT >

pcl::ApproximateProgressiveMorphologicalFilter< PointT >::ApproximateProgressiveMorphologicalFilter | ( |  | ) |

Constructor that sets default values for member variables.

Definition at line 52 of file approximate_progressive_morphological_filter.hpp.

## ~ApproximateProgressiveMorphologicalFilter()

template<typename PointT >

pcl::ApproximateProgressiveMorphologicalFilter< PointT >::~ApproximateProgressiveMorphologicalFilter | ( |  | ) |

virtual

Definition at line 66 of file approximate_progressive_morphological_filter.hpp.

## Member Function Documentation

## extract()

template<typename PointT >

void pcl::ApproximateProgressiveMorphologicalFilter< PointT >::extract | ( | std::vector< int > & | ground | ) |

virtual

This method launches the segmentation algorithm and returns indices of points determined to be ground returns.

Parameters

  [out] | ground | indices of points determined to be ground returns.

Definition at line 72 of file approximate_progressive_morphological_filter.hpp.

References pcl::ApproximateProgressiveMorphologicalFilter< PointT >::base_, pcl::ApproximateProgressiveMorphologicalFilter< PointT >::cell_size_, pcl::PCLBase< PointT >::deinitCompute(), pcl::ApproximateProgressiveMorphologicalFilter< PointT >::exponential_, pcl::PCLBase< PointT >::indices_, pcl::PCLBase< PointT >::initCompute(), pcl::ApproximateProgressiveMorphologicalFilter< PointT >::initial_distance_, pcl::PCLBase< PointT >::input_, pcl::ApproximateProgressiveMorphologicalFilter< PointT >::max_distance_, pcl::ApproximateProgressiveMorphologicalFilter< PointT >::max_window_size_, pcl::PointCloud< PointT >::points, and pcl::ApproximateProgressiveMorphologicalFilter< PointT >::slope_.

## getBase()

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::getBase | ( |  | ) | const

inline

Get the base to be used in computing progressive window sizes.

Definition at line 118 of file approximate_progressive_morphological_filter.h.

## getCellSize()

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::getCellSize | ( |  | ) | const

inline

Get the cell size.

Definition at line 110 of file approximate_progressive_morphological_filter.h.

## getExponential()

template<typename PointT >

bool pcl::ApproximateProgressiveMorphologicalFilter< PointT >::getExponential | ( |  | ) | const

inline

Get flag indicating whether or not to exponentially grow window sizes?

Definition at line 126 of file approximate_progressive_morphological_filter.h.

## getInitialDistance()

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::getInitialDistance | ( |  | ) | const

inline

Get the initial height above the parameterized ground surface to be considered a ground return.

Definition at line 102 of file approximate_progressive_morphological_filter.h.

## getMaxDistance()

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::getMaxDistance | ( |  | ) | const

inline

Get the maximum height above the parameterized ground surface to be considered a ground return.

Definition at line 94 of file approximate_progressive_morphological_filter.h.

## getMaxWindowSize()

template<typename PointT >

int pcl::ApproximateProgressiveMorphologicalFilter< PointT >::getMaxWindowSize | ( |  | ) | const

inline

Get the maximum window size to be used in filtering ground returns.

Definition at line 78 of file approximate_progressive_morphological_filter.h.

## getSlope()

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::getSlope | ( |  | ) | const

inline

Get the slope value to be used in computing the height threshold.

Definition at line 86 of file approximate_progressive_morphological_filter.h.

## setBase()

template<typename PointT >

void pcl::ApproximateProgressiveMorphologicalFilter< PointT >::setBase | ( | float | base | ) |

inline

Set the base to be used in computing progressive window sizes.

Definition at line 122 of file approximate_progressive_morphological_filter.h.

## setCellSize()

template<typename PointT >

void pcl::ApproximateProgressiveMorphologicalFilter< PointT >::setCellSize | ( | float | cell_size | ) |

inline

Set the cell size.

Definition at line 114 of file approximate_progressive_morphological_filter.h.

## setExponential()

template<typename PointT >

void pcl::ApproximateProgressiveMorphologicalFilter< PointT >::setExponential | ( | bool | exponential | ) |

inline

Set flag indicating whether or not to exponentially grow window sizes?

Definition at line 130 of file approximate_progressive_morphological_filter.h.

## setInitialDistance()

template<typename PointT >

void pcl::ApproximateProgressiveMorphologicalFilter< PointT >::setInitialDistance | ( | float | initial_distance | ) |

inline

Set the initial height above the parameterized ground surface to be considered a ground return.

Definition at line 106 of file approximate_progressive_morphological_filter.h.

## setMaxDistance()

template<typename PointT >

void pcl::ApproximateProgressiveMorphologicalFilter< PointT >::setMaxDistance | ( | float | max_distance | ) |

inline

Set the maximum height above the parameterized ground surface to be considered a ground return.

Definition at line 98 of file approximate_progressive_morphological_filter.h.

## setMaxWindowSize()

template<typename PointT >

void pcl::ApproximateProgressiveMorphologicalFilter< PointT >::setMaxWindowSize | ( | int | max_window_size | ) |

inline

Set the maximum window size to be used in filtering ground returns.

Definition at line 82 of file approximate_progressive_morphological_filter.h.

## setNumberOfThreads()

template<typename PointT >

void pcl::ApproximateProgressiveMorphologicalFilter< PointT >::setNumberOfThreads | ( | unsigned int | nr_threads = `0` | ) |

inline

Initialize the scheduler and set the number of threads to use.

Parameters

  nr_threads | the number of hardware threads to use (0 sets the value back to automatic)

Definition at line 136 of file approximate_progressive_morphological_filter.h.

## setSlope()

template<typename PointT >

void pcl::ApproximateProgressiveMorphologicalFilter< PointT >::setSlope | ( | float | slope | ) |

inline

Set the slope value to be used in computing the height threshold.

Definition at line 90 of file approximate_progressive_morphological_filter.h.

## Member Data Documentation

## base_

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::base_

protected

Base to be used in computing progressive window sizes.

Definition at line 163 of file approximate_progressive_morphological_filter.h.

Referenced by pcl::ApproximateProgressiveMorphologicalFilter< PointT >::extract().

## cell_size_

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::cell_size_

protected

Cell size.

Definition at line 160 of file approximate_progressive_morphological_filter.h.

Referenced by pcl::ApproximateProgressiveMorphologicalFilter< PointT >::extract().

## exponential_

template<typename PointT >

bool pcl::ApproximateProgressiveMorphologicalFilter< PointT >::exponential_

protected

Exponentially grow window sizes?

Definition at line 166 of file approximate_progressive_morphological_filter.h.

Referenced by pcl::ApproximateProgressiveMorphologicalFilter< PointT >::extract().

## initial_distance_

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::initial_distance_

protected

Initial height above the parameterized ground surface to be considered a ground return.

Definition at line 157 of file approximate_progressive_morphological_filter.h.

Referenced by pcl::ApproximateProgressiveMorphologicalFilter< PointT >::extract().

## max_distance_

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::max_distance_

protected

Maximum height above the parameterized ground surface to be considered a ground return.

Definition at line 154 of file approximate_progressive_morphological_filter.h.

Referenced by pcl::ApproximateProgressiveMorphologicalFilter< PointT >::extract().

## max_window_size_

template<typename PointT >

int pcl::ApproximateProgressiveMorphologicalFilter< PointT >::max_window_size_

protected

Maximum window size to be used in filtering ground returns.

Definition at line 148 of file approximate_progressive_morphological_filter.h.

Referenced by pcl::ApproximateProgressiveMorphologicalFilter< PointT >::extract().

## slope_

template<typename PointT >

float pcl::ApproximateProgressiveMorphologicalFilter< PointT >::slope_

protected

Slope value to be used in computing the height threshold.

Definition at line 151 of file approximate_progressive_morphological_filter.h.

Referenced by pcl::ApproximateProgressiveMorphologicalFilter< PointT >::extract().

## threads_

template<typename PointT >

unsigned int pcl::ApproximateProgressiveMorphologicalFilter< PointT >::threads_

protected

Number of threads to be used.

Definition at line 169 of file approximate_progressive_morphological_filter.h.

The documentation for this class was generated from the following files:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/segmentation/include/pcl/segmentation/approximate_progressive_morphological_filter.h
- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/segmentation/include/pcl/segmentation/impl/approximate_progressive_morphological_filter.hpp